/*****************************************************************************
 * The contents of this file are subject to the RECIPROCAL PUBLIC LICENSE
 * Version 1.1 ("License"); You may not use this file except in compliance
 * with the License. You may obtain a copy of the License at
 * http://opensource.org/licenses/rpl.php. Software distributed under the
 * License is distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY KIND,
 * either express or implied.
 *
 * @author:  Bernard Rienks
 * @email:   bcrienks@webonomic.nl
 * @version: 1 
 * @date:    2007-11-25
 *
 *****************************************************************************/
// this PSPAD script will automatically compress js files with two compressors:
// - the Yahoo compressor: http://developer.yahoo.com/yui/compressor
// - PHP Packer of Dean Edwards : http://joliclic.free.fr/php/javascript-packer/en/
// It will also create gzip javascript files of the original and the two compressed
// files for comparison.
// http://www.7-zip.org/
// Note: In real life you don't need gzipped js files, your webserver can do that on the fly!
// How to serve gzipped js files from your webserver:
// http://www.mybelovedphp.com/category/apache/

// EDIT THESE LINES TO SET PATHS

	// path to YUI compressor notice double (escaped) \\
	var	YUI_path = "D:\\Program Files\\Tools\\yuicompressor-2.2.5.jar";

// SET phppacker '1' to PHP pack files or '' to skip (when PHPpacker  not installed)
	var phppacker = '1';
	// path to php executable
	var	php_path     = "e:\\xampp\\php\\php.exe";
	// path to JavaScriptPacker.php
	var	packer_path = "e:\\xampp\\htdocs\\JavaScriptPacker.php";

 // SET gzip '1' to gzip files or '' to skip gzip (when 7z not installed)
	var gzip = '1';
	// path to 7zip to gzip files
	var	z_path = "D:\\Program Files\\7-Zip\\7z";


// END EDIT


function JSpacker() {

	var fso = new ActiveXObject("Scripting.FileSystemObject");
	
  
	
	var	yuiParams = "-o ";
	var ed = newEditor();
  ed.assignActiveEditor();
  var cx = ed.caretX();
  var cy = ed.caretY();
  var fn = ed.fileName();
  var fnYui = fn+".YUI_PACKED.js";
  var fnPacker = fn+".PHP_PACKED.js";
  if(!fn.match(/\.js$/)) {
		echo("NOT A JavaScript FILE!");
		return;
	}
  var sh = new ActiveXObject("WScript.shell");

	// comment this part if u don't want to use YUI compressor
	sh.run('cmd /c java -jar "'+YUI_path+'" "'+fn+'" '+yuiParams+' "'+fnYui+'"', 0, false);
	
	// end YUI part
	
	// comment this part if u don't want to use PHPPACKER compressor
	if (phppacker){
	sh.run('cmd /c ""'+php_path+'" -f "'+packer_path+'" "'+fn+'" "'+fnPacker+'""', 0, true);
}
  // end PHPPACKER part

	// 7zip gzipping
	// comment lines if u don't want files to be gzipped
	if (gzip){
	sh.run('\"'+z_path+'\" a -tgzip \"'+fn+'.gz\"'+' \"'+fn+'\"',0);
	sh.run('\"'+z_path+'\" a -tgzip \"'+fnYui+'.gz\"'+' \"'+fnYui+'\"',0);
	if (phppacker){
	sh.run('\"'+z_path+'\" a -tgzip \"'+fnPacker+'.gz\"'+' \"'+fnPacker+'\"',0);
	}
}

  edn = newEditor();
	edn.openFile(fnYui);
 	ed.Text();
 	
  logClear();
 	edn.openFile(fnYui).aInfo;

if (phppacker){
	edn2 = newEditor();
 	edn2.openFile(fnPacker);
 	ed.Text();
 	}
 	
  ed.caretX(cx);
  ed.caretY(cy);

	// comment appropriate line if u have commented above
  logAddLine ('Original            : '+ fso.GetFile(fn).size);
  logAddLine ('YUI packed          : '+ fso.GetFile(fnYui).size);
  if (phppacker){
  logAddLine ('PHP packer packed   : '+ fso.GetFile(fnPacker).size);
  }
if (gzip){
	logAddLine ('gzipped YUI packed  : '+ fso.GetFile(fnYui+'.gz').size);
	if (phppacker){
  logAddLine ('gzipped PHP packer  : '+ fso.GetFile(fnPacker+'.gz').size);
  }
  logAddLine ('gzipped Original    : '+ fso.GetFile(fn+'.gz').size);
}
}

function Init(){
  addMenuItem("JSpacker", "", "JSpacker", "CTRL+Y");
}
